package fyloz.trial.ColorRecipesExplorer.core;

public enum ResponseCode {
    SUCCESS_USING_MATERIALS(1, ResponseCodeType.SUCCESS, 0),
    SUCCESS_SAVING_RECIPE_INFORMATIONS(2, ResponseCodeType.SUCCESS, 0),
    ERROR_SAVING(3, ResponseCodeType.ERROR, 0),
    ERROR_SAVING_IMAGE(4, ResponseCodeType.ERROR, 0),
    ERROR_SAVING_SIMDUT(5, ResponseCodeType.ERROR, 0),
    AUTH_ERROR(6, ResponseCodeType.ERROR, 0),
    RECIPE_NOT_FOUND(7, ResponseCodeType.ERROR, 1),
    MIX_NOT_FOUND(8, ResponseCodeType.ERROR, 1),
    MATERIAL_NOT_FOUND(9, ResponseCodeType.ERROR, 1),
    MATERIAL_ALREADY_EXIST(10, ResponseCodeType.ERROR, 1),
    MATERIAL_TYPE_ALREADY_EXIST(11, ResponseCodeType.ERROR, 1),
    COMPANY_NOT_FOUND(12, ResponseCodeType.ERROR, 1),
    COMPANY_ALREADY_EXIST(13, ResponseCodeType.ERROR, 1),
    MATERIAL_LINKED(14, ResponseCodeType.ERROR, 1),
    COMPANY_LINKED(15, ResponseCodeType.ERROR, 1),
    MIX_NOT_ASSOCIATED_WITH_RECIPE(16, ResponseCodeType.ERROR, 2),
    NOT_ENOUGH_MATERIAL(17, ResponseCodeType.ERROR, 1),
    MIX_TYPE_ALREADY_USED(18, ResponseCodeType.ERROR, 1);

    public static final int MAX_PARAMETERS_NUMBER = 2;

    private int code;
    private ResponseCodeType type;
    private int parametersNumber;

    ResponseCode(int code, ResponseCodeType type, int parametersNumber) {
        this.code = code;
        this.type = type;
        this.parametersNumber = parametersNumber;
    }

    public int getCode() {
        return code;
    }

    public ResponseCodeType getType() {
        return type;
    }

    public int getParametersNumber() {
        return parametersNumber;
    }

    public enum ResponseCodeType {
        ERROR,
        SUCCESS
    }
}
